Index: uspace/lib/posix/internal/common.h
===================================================================
--- uspace/lib/posix/internal/common.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/internal/common.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Helper definitions common for all libposix files.
  */
 
Index: uspace/lib/posix/inttypes.h
===================================================================
--- uspace/lib/posix/inttypes.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/inttypes.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Fixed size integer types.
  */
 
@@ -39,4 +39,14 @@
 #include "libc/inttypes.h"
 
+extern posix_intmax_t posix_strtoimax(const char *restrict nptr,
+    char **restrict endptr, int base);
+extern posix_uintmax_t posix_strtoumax(const char *restrict nptr,
+    char **restrict endptr, int base);
+
+#ifndef LIBPOSIX_INTERNAL
+	#define strtoimax posix_strtoimax
+	#define strtoumax posix_strtoumax
+#endif
+
 #endif /* POSIX_INTTYPES_H_ */
 
Index: uspace/lib/posix/iso646.h
===================================================================
--- uspace/lib/posix/iso646.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/iso646.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -1,7 +1,34 @@
+/*
+ * Copyright (c) 2011 Jiri Zarevucky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
 
 /** @addtogroup libposix
  * @{
  */
-/** @file
+/** @file Alternative spellings.
  */
 
@@ -25,3 +52,2 @@
 /** @}
  */
-
Index: uspace/lib/posix/limits.h
===================================================================
--- uspace/lib/posix/limits.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/limits.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Implementation-defined limit constants.
  */
 
Index: uspace/lib/posix/locale.c
===================================================================
--- uspace/lib/posix/locale.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/locale.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Locale-specific definitions.
  */
 
@@ -41,4 +41,6 @@
 #include "limits.h"
 #include "string.h"
+
+// TODO: documentation
 
 struct __posix_locale {
@@ -73,4 +75,10 @@
 };
 
+/**
+ * 
+ * @param category
+ * @param locale
+ * @return
+ */
 char *posix_setlocale(int category, const char *locale)
 {
@@ -83,4 +91,8 @@
 }
 
+/**
+ * 
+ * @return
+ */
 struct posix_lconv *posix_localeconv(void)
 {
@@ -89,4 +101,9 @@
 }
 
+/**
+ * 
+ * @param locobj
+ * @return
+ */
 posix_locale_t posix_duplocale(posix_locale_t locobj)
 {
@@ -104,9 +121,22 @@
 }
 
+/**
+ * 
+ * @param locobj
+ */
 void posix_freelocale(posix_locale_t locobj)
 {
-	free(locobj);
+	if (locobj) {
+		free(locobj);
+	}
 }
 
+/**
+ * 
+ * @param category_mask
+ * @param locale
+ * @param base
+ * @return
+ */
 posix_locale_t posix_newlocale(int category_mask, const char *locale,
     posix_locale_t base)
@@ -129,5 +159,10 @@
 }
 
-posix_locale_t posix_uselocale (posix_locale_t newloc)
+/**
+ * 
+ * @param newloc
+ * @return
+ */
+posix_locale_t posix_uselocale(posix_locale_t newloc)
 {
 	// TODO
Index: uspace/lib/posix/locale.h
===================================================================
--- uspace/lib/posix/locale.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/locale.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,9 +30,11 @@
  * @{
  */
-/** @file
+/** @file Locale-specific definitions.
  */
 
 #ifndef POSIX_LOCALE_H_
 #define POSIX_LOCALE_H_
+
+// TODO: documentation
 
 #ifndef NULL
@@ -83,28 +85,28 @@
 
 struct posix_lconv {
-	char    *currency_symbol;
-	char    *decimal_point;
-	char     frac_digits;
-	char    *grouping;
-	char    *int_curr_symbol;
-	char     int_frac_digits;
-	char     int_n_cs_precedes;
-	char     int_n_sep_by_space;
-	char     int_n_sign_posn;
-	char     int_p_cs_precedes;
-	char     int_p_sep_by_space;
-	char     int_p_sign_posn;
-	char    *mon_decimal_point;
-	char    *mon_grouping;
-	char    *mon_thousands_sep;
-	char    *negative_sign;
-	char     n_cs_precedes;
-	char     n_sep_by_space;
-	char     n_sign_posn;
-	char    *positive_sign;
-	char     p_cs_precedes;
-	char     p_sep_by_space;
-	char     p_sign_posn;
-	char    *thousands_sep;
+	char *currency_symbol;
+	char *decimal_point;
+	char  frac_digits;
+	char *grouping;
+	char *int_curr_symbol;
+	char  int_frac_digits;
+	char  int_n_cs_precedes;
+	char  int_n_sep_by_space;
+	char  int_n_sign_posn;
+	char  int_p_cs_precedes;
+	char  int_p_sep_by_space;
+	char  int_p_sign_posn;
+	char *mon_decimal_point;
+	char *mon_grouping;
+	char *mon_thousands_sep;
+	char *negative_sign;
+	char  n_cs_precedes;
+	char  n_sep_by_space;
+	char  n_sign_posn;
+	char *positive_sign;
+	char  p_cs_precedes;
+	char  p_sep_by_space;
+	char  p_sign_posn;
+	char *thousands_sep;
 };
 
@@ -117,5 +119,5 @@
 extern posix_locale_t posix_newlocale(int category_mask, const char *locale,
     posix_locale_t base);
-extern posix_locale_t posix_uselocale (posix_locale_t newloc);
+extern posix_locale_t posix_uselocale(posix_locale_t newloc);
 
 #ifndef LIBPOSIX_INTERNAL
@@ -131,5 +133,4 @@
 #endif
 
-
 #endif /* POSIX_LOCALE_H_ */
 
Index: uspace/lib/posix/math.c
===================================================================
--- uspace/lib/posix/math.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/math.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Mathematical operations.
  */
 
Index: uspace/lib/posix/math.h
===================================================================
--- uspace/lib/posix/math.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/math.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Mathematical operations.
  */
 
Index: uspace/lib/posix/pwd.c
===================================================================
--- uspace/lib/posix/pwd.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/pwd.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,12 +30,14 @@
  * @{
  */
-/** @file
+/** @file Password handling.
  */
 
 #define LIBPOSIX_INTERNAL
+
 #include "pwd.h"
 #include "string.h"
 #include "errno.h"
 
+// TODO: documentation
 
 static bool entry_read = false;
@@ -53,4 +55,6 @@
  * Since HelenOS doesn't have user accounts, this always returns
  * the same made-up entry.
+ *
+ * @return
  */
 struct posix_passwd *posix_getpwent(void)
@@ -178,3 +182,2 @@
 /** @}
  */
-
Index: uspace/lib/posix/pwd.h
===================================================================
--- uspace/lib/posix/pwd.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/pwd.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,9 +30,11 @@
  * @{
  */
-/** @file
+/** @file Password handling.
  */
 
 #ifndef POSIX_PWD_H_
 #define POSIX_PWD_H_
+
+// TODO: documentation
 
 #include "sys/types.h"
@@ -76,3 +78,2 @@
 /** @}
  */
-
Index: uspace/lib/posix/signal.c
===================================================================
--- uspace/lib/posix/signal.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/signal.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Signal handling.
  */
 
@@ -45,4 +45,6 @@
 #include "libc/task.h"
 
+// TODO: documentation
+
 /* Used to serialize signal handling. */
 static FIBRIL_MUTEX_INITIALIZE(_signal_mutex);
@@ -63,4 +65,8 @@
 };
 
+/**
+ * 
+ * @param signo
+ */
 void __posix_default_signal_handler(int signo)
 {
@@ -118,4 +124,8 @@
 }
 
+/**
+ *
+ * @param signo
+ */
 void __posix_hold_signal_handler(int signo)
 {
@@ -123,4 +133,8 @@
 }
 
+/**
+ * 
+ * @param signo
+ */
 void __posix_ignore_signal_handler(int signo)
 {
@@ -128,5 +142,9 @@
 }
 
-
+/**
+ * 
+ * @param set
+ * @return
+ */
 int posix_sigemptyset(posix_sigset_t *set)
 {
@@ -137,4 +155,9 @@
 }
 
+/**
+ * 
+ * @param set
+ * @return
+ */
 int posix_sigfillset(posix_sigset_t *set)
 {
@@ -145,4 +168,10 @@
 }
 
+/**
+ * 
+ * @param set
+ * @param signo
+ * @return
+ */
 int posix_sigaddset(posix_sigset_t *set, int signo)
 {
@@ -153,4 +182,10 @@
 }
 
+/**
+ * 
+ * @param set
+ * @param signo
+ * @return
+ */
 int posix_sigdelset(posix_sigset_t *set, int signo)
 {
@@ -161,4 +196,10 @@
 }
 
+/**
+ * 
+ * @param set
+ * @param signo
+ * @return
+ */
 int posix_sigismember(const posix_sigset_t *set, int signo)
 {
@@ -168,4 +209,10 @@
 }
 
+/**
+ * 
+ * @param sig
+ * @param act
+ * @param oact
+ */
 static void _sigaction_unsafe(int sig, const struct posix_sigaction *restrict act,
     struct posix_sigaction *restrict oact)
@@ -182,4 +229,11 @@
 }
 
+/**
+ * 
+ * @param sig
+ * @param act
+ * @param oact
+ * @return
+ */
 int posix_sigaction(int sig, const struct posix_sigaction *restrict act,
     struct posix_sigaction *restrict oact)
@@ -206,4 +260,10 @@
 }
 
+/**
+ * 
+ * @param sig
+ * @param func
+ * @return
+ */
 void (*posix_signal(int sig, void (*func)(int)))(int)
 {
@@ -222,4 +282,10 @@
 }
 
+/**
+ * 
+ * @param signo
+ * @param siginfo
+ * @return
+ */
 static int _raise_sigaction(int signo, posix_siginfo_t *siginfo)
 {
@@ -259,4 +325,9 @@
 }
 
+/**
+ * 
+ * @param sig
+ * @return
+ */
 int posix_raise(int sig)
 {
@@ -273,4 +344,10 @@
 }
 
+/**
+ * 
+ * @param pid
+ * @param signo
+ * @return
+ */
 int posix_kill(posix_pid_t pid, int signo)
 {
@@ -303,4 +380,10 @@
 }
 
+/**
+ * 
+ * @param pid
+ * @param sig
+ * @return
+ */
 int posix_killpg(posix_pid_t pid, int sig)
 {
@@ -309,4 +392,9 @@
 }
 
+/**
+ * 
+ * @param pinfo
+ * @param message
+ */
 void posix_psiginfo(const posix_siginfo_t *pinfo, const char *message)
 {
@@ -316,4 +404,9 @@
 }
 
+/**
+ * 
+ * @param signum
+ * @param message
+ */
 void posix_psignal(int signum, const char *message)
 {
@@ -326,4 +419,11 @@
 }
 
+/**
+ * 
+ * @param how
+ * @param set
+ * @param oset
+ * @return
+ */
 int posix_thread_sigmask(int how, const posix_sigset_t *restrict set,
     posix_sigset_t *restrict oset)
@@ -358,4 +458,11 @@
 }
 
+/**
+ * 
+ * @param how
+ * @param set
+ * @param oset
+ * @return
+ */
 int posix_sigprocmask(int how, const posix_sigset_t *restrict set,
     posix_sigset_t *restrict oset)
@@ -371,3 +478,2 @@
 /** @}
  */
-
Index: uspace/lib/posix/signal.h
===================================================================
--- uspace/lib/posix/signal.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/signal.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,9 +30,11 @@
  * @{
  */
-/** @file
+/** @file Signal handling.
  */
 
 #ifndef POSIX_SIGNAL_H_
 #define POSIX_SIGNAL_H_
+
+// TODO: documentation
 
 #include "libc/errno.h"
@@ -107,5 +109,4 @@
 	posix_mcontext_t uc_mcontext;
 } posix_ucontext_t;
-
 
 /* Values of posix_sigevent::sigev_notify */
@@ -154,5 +155,5 @@
 #define SIGSTKSZ 0
 
-/* full POSIX set */
+/* Full POSIX set */
 enum {
 	/* Termination Signals */
@@ -214,5 +215,4 @@
 
 /* Values for sigaction field si_code. */
-
 enum {
 	SI_USER,
@@ -287,9 +287,10 @@
 		#define sigevent posix_sigevent
 	#endif
-	#define sigaction posix_sigaction
 	#define mcontext_t posix_mcontext_t
 	#define ucontext_t posix_ucontext_t
 	#define stack_t posix_stack_t
 	#define siginfo_t posix_siginfo_t
+
+	#define sigaction posix_sigaction
 
 	#define signal posix_signal
Index: uspace/lib/posix/stdbool.h
===================================================================
--- uspace/lib/posix/stdbool.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stdbool.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Boolean type and values.
  */
 
@@ -50,3 +50,2 @@
 
 #endif /* POSIX_STDBOOL_H_ */
-
Index: uspace/lib/posix/stddef.h
===================================================================
--- uspace/lib/posix/stddef.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stddef.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Standard type definitions.
  */
 
Index: uspace/lib/posix/stdint.h
===================================================================
--- uspace/lib/posix/stdint.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stdint.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Integer types.
  */
 
@@ -88,4 +88,14 @@
 #define AOFF64_MIN  UINT64_MIN
 
+#undef INTMAX_MIN
+#undef INTMAX_MAX
+#define INTMAX_MIN INT64_MIN
+#define INTMAX_MAX INT64_MAX
+
+#undef UINTMAX_MIN
+#undef UINTMAX_MAX
+#define UINTMAX_MIN UINT64_MIN
+#define UINTMAX_MAX UINT64_MAX
+
 #include "libc/sys/types.h"
 
Index: uspace/lib/posix/stdio.c
===================================================================
--- uspace/lib/posix/stdio.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stdio.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Standard buffered input/output.
  */
 
@@ -355,9 +355,10 @@
 {
 	off64_t ret = ftell(stream);
-	if (ret == -1) {
-		return errno;
-	}
-	pos->offset = ret;
-	return 0;
+	if (ret != -1) {
+		pos->offset = ret;
+		return 0;
+	} else {
+		return -1;
+	}
 }
 
Index: uspace/lib/posix/stdio.h
===================================================================
--- uspace/lib/posix/stdio.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stdio.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Standard buffered input/output.
  */
 
Index: uspace/lib/posix/stdio/scanf.c
===================================================================
--- uspace/lib/posix/stdio/scanf.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stdio/scanf.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -303,6 +303,8 @@
 	self->fetched = 0;
 	self->cursor = NULL;
-	free(self->window);
-	self->window = NULL;
+	if (self->window) {
+		free(self->window);
+		self->window = NULL;
+	}
 	self->window_size = 0;
 	self->state = _PROV_CONSTRUCTED;
@@ -653,5 +655,5 @@
 				/* Update the cursor so it can be returned to the provider. */
 				cur_borrowed += cur_updated - cur_limited;
-				if (width != -1) {
+				if (width != -1 && cur_limited != NULL) {
 					/* Deallocate duplicated part of the cursor view. */
 					free(cur_limited);
@@ -833,5 +835,5 @@
 				/* Update the cursor so it can be returned to the provider. */
 				cur_borrowed += cur_updated - cur_limited;
-				if (width != -1) {
+				if (width != -1 && cur_limited != NULL) {
 					/* Deallocate duplicated part of the cursor view. */
 					free(cur_limited);
Index: uspace/lib/posix/stdlib.c
===================================================================
--- uspace/lib/posix/stdlib.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stdlib.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Standard library definitions.
  */
 
@@ -40,4 +40,5 @@
 
 #include "errno.h"
+#include "limits.h"
 
 #include "libc/sort.h"
@@ -59,4 +60,5 @@
 
 /**
+ * Integer absolute value.
  * 
  * @param i Input value.
@@ -69,4 +71,5 @@
 
 /**
+ * Long integer absolute value.
  * 
  * @param i Input value.
@@ -79,4 +82,5 @@
 
 /**
+ * Long long integer absolute value.
  * 
  * @param i Input value.
@@ -88,4 +92,11 @@
 }
 
+/**
+ * Compute the quotient and remainder of an integer division.
+ *
+ * @param numer Numerator.
+ * @param denom Denominator.
+ * @return Quotient and remainder packed into structure.
+ */
 posix_div_t posix_div(int numer, int denom)
 {
@@ -93,4 +104,11 @@
 }
 
+/**
+ * Compute the quotient and remainder of a long integer division.
+ *
+ * @param numer Numerator.
+ * @param denom Denominator.
+ * @return Quotient and remainder packed into structure.
+ */
 posix_ldiv_t posix_ldiv(long numer, long denom)
 {
@@ -98,4 +116,11 @@
 }
 
+/**
+ * Compute the quotient and remainder of a long long integer division.
+ *
+ * @param numer Numerator.
+ * @param denom Denominator.
+ * @return Quotient and remainder packed into structure.
+ */
 posix_lldiv_t posix_lldiv(long long numer, long long denom)
 {
@@ -109,5 +134,4 @@
  * @param elem2 Second element to compare.
  * @param compare Comparison function without userdata parameter.
- *
  * @return Relative ordering of the elements.
  */
@@ -115,5 +139,14 @@
 {
 	int (*compare)(const void *, const void *) = userdata;
-	return compare(elem1, elem2);
+	int ret = compare(elem1, elem2);
+	
+	/* Native qsort internals expect this. */
+	if (ret < 0) {
+		return -1;
+	} else if (ret > 0) {
+		return 1;
+	} else {
+		return 0;
+	}
 }
 
@@ -121,8 +154,8 @@
  * Array sorting utilizing the quicksort algorithm.
  *
- * @param array
- * @param count
- * @param size
- * @param compare
+ * @param array Array of elements to sort.
+ * @param count Number of elements in the array.
+ * @param size Width of each element.
+ * @param compare Decides relative ordering of two elements.
  */
 void posix_qsort(void *array, size_t count, size_t size,
@@ -171,9 +204,10 @@
 /**
  * Retrieve a value of the given environment variable.
+ *
  * Since HelenOS doesn't support env variables at the moment,
  * this function always returns NULL.
  *
- * @param name
- * @return Always NULL.
+ * @param name Name of the variable.
+ * @return Value of the variable or NULL if such variable does not exist.
  */
 char *posix_getenv(const char *name)
@@ -195,7 +229,10 @@
 
 /**
- *
- * @param string String to be passed to a command interpreter.
- * @return
+ * Issue a command.
+ *
+ * @param string String to be passed to a command interpreter or NULL.
+ * @return Termination status of the command if the command is not NULL,
+ *     otherwise indicate whether there is a command interpreter (non-zero)
+ *     or not (zero).
  */
 int posix_system(const char *string) {
@@ -205,10 +242,14 @@
 
 /**
- * 
- * @param name
- * @param resolved
- * @return
- */
-char *posix_realpath(const char *name, char *resolved)
+ * Resolve absolute pathname.
+ * 
+ * @param name Pathname to be resolved.
+ * @param resolved Either buffer for the resolved absolute pathname or NULL.
+ * @return On success, either resolved (if it was not NULL) or pointer to the
+ *     newly allocated buffer containing the absolute pathname (if resolved was
+ *     NULL). Otherwise NULL.
+ *
+ */
+char *posix_realpath(const char *restrict name, char *restrict resolved)
 {
 	#ifndef PATH_MAX
@@ -254,6 +295,6 @@
  * its native representation. See posix_strtold().
  *
- * @param nptr
- * @return
+ * @param nptr String representation of a floating-point number.
+ * @return Double-precision number resulting from the string conversion.
  */
 double posix_atof(const char *nptr)
@@ -266,7 +307,8 @@
  * its native representation. See posix_strtold().
  *
- * @param nptr
- * @param endptr
- * @return
+ * @param nptr String representation of a floating-point number.
+ * @param endptr Pointer to the final part of the string which
+ *     was not used for conversion.
+ * @return Single-precision number resulting from the string conversion.
  */
 float posix_strtof(const char *restrict nptr, char **restrict endptr)
@@ -279,7 +321,8 @@
  * its native representation. See posix_strtold().
  *
- * @param nptr
- * @param endptr
- * @return
+ * @param nptr String representation of a floating-point number.
+ * @param endptr Pointer to the final part of the string which
+ *     was not used for conversion.
+ * @return Double-precision number resulting from the string conversion.
  */
 double posix_strtod(const char *restrict nptr, char **restrict endptr)
@@ -289,7 +332,8 @@
 
 /**
- *
- * @param size
- * @return
+ * Allocate memory chunk.
+ *
+ * @param size Size of the chunk to allocate.
+ * @return Either pointer to the allocated chunk or NULL if not possible.
  */
 void *posix_malloc(size_t size)
@@ -299,8 +343,9 @@
 
 /**
- *
- * @param nelem
- * @param elsize
- * @return
+ * Allocate memory for an array of elements.
+ *
+ * @param nelem Number of elements in the array.
+ * @param elsize Size of each element.
+ * @return Either pointer to the allocated array or NULL if not possible.
  */
 void *posix_calloc(size_t nelem, size_t elsize)
@@ -310,21 +355,31 @@
 
 /**
- *
- * @param ptr
- * @param size
- * @return
+ * Reallocate memory chunk to a new size.
+ *
+ * @param ptr Memory chunk to reallocate. Might be NULL.
+ * @param size Size of the reallocated chunk. Might be zero.
+ * @return Either NULL or the pointer to the newly reallocated chunk.
  */
 void *posix_realloc(void *ptr, size_t size)
 {
-	return realloc(ptr, size);
-}
-
-/**
- *
- * @param ptr
+	if (ptr != NULL && size == 0) {
+		/* Native realloc does not handle this special case. */
+		free(ptr);
+		return NULL;
+	} else {
+		return realloc(ptr, size);
+	}
+}
+
+/**
+ * Free allocated memory chunk.
+ *
+ * @param ptr Memory chunk to be freed.
  */
 void posix_free(void *ptr)
 {
-	free(ptr);
+	if (ptr) {
+		free(ptr);
+	}
 }
 
@@ -341,9 +396,11 @@
 
 /**
- * Should read system load statistics. Not supported. Always returns -1.
- *
- * @param loadavg
- * @param nelem
- * @return
+ * Get system load average statistics.
+ *
+ * Not supported. Always returns -1.
+ *
+ * @param loadavg Array where the load averages shall be placed.
+ * @param nelem Maximum number of elements to be placed into the array.
+ * @return Number of elements placed into the array on success, -1 otherwise.
  */
 int bsd_getloadavg(double loadavg[], int nelem)
Index: uspace/lib/posix/stdlib.h
===================================================================
--- uspace/lib/posix/stdlib.h	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stdlib.h	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -31,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Standard library definitions.
  */
 
@@ -56,5 +56,5 @@
 extern long long posix_llabs(long long i);
 
-/* Integer division */
+/* Integer Division */
 
 typedef struct {
@@ -80,11 +80,8 @@
     size_t nmemb, size_t size, int (*compar)(const void *, const void *));
 
-
 /* Environment Access */
 extern char *posix_getenv(const char *name);
 extern int posix_putenv(char *string);
-
 extern int posix_system(const char *string);
-
 
 /* Symbolic Links */
@@ -101,5 +98,4 @@
 extern long int posix_atol(const char *nptr);
 extern long long int posix_atoll(const char *nptr);
-
 extern long int posix_strtol(const char *restrict nptr,
     char **restrict endptr, int base);
@@ -110,5 +106,4 @@
 extern unsigned long long int posix_strtoull(
     const char *restrict nptr, char **restrict endptr, int base);
-
 
 /* Memory Allocation */
